"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});


var relay = {
  insideFragment: function insideFragment(componentName, fragmentKey) {
    return "${" + componentName + ".getFragment('" + fragmentKey + "')}";
  },
  outsideFragment: function outsideFragment() {
    return null;
  }
};

var uppercaseFirstChar = function uppercaseFirstChar(str) {
  return str.charAt(0).toUpperCase() + str.slice(1);
};

var apolloFragmentName = function apolloFragmentName(componentName, fragmentKey) {
  var fragName = uppercaseFirstChar(fragmentKey);
  return "" + componentName + fragName + "Fragment";
};

var apollo = {
  insideFragment: function insideFragment(componentName, fragmentKey) {
    return "..." + apolloFragmentName(componentName, fragmentKey);
  },
  outsideFragment: function outsideFragment(componentName, fragmentKey) {
    return "${" + componentName + ".fragments." + fragmentKey + "}";
  }
};

exports.relay = relay;
exports.apollo = apollo;
exports.apolloFragmentName = apolloFragmentName;