"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();
/* eslint no-param-reassign:0 */


exports.default = function (schema) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var genFragFromPropsName = options.genFragFromPropsName || "generateFragmentFromProps";
  var genFragFromPropsNameFor = options.genFragFromPropsNameFor || "generateFragmentFromPropsFor";
  var defaultTemplateTag = options.defaultTemplateTag || "() => Relay.QL";
  var defaultFragmentName = options.defaultFragmentName || function noop() {
    return null;
  };
  var childFragmentTransformations = options.childFragmentTransformations || _ChildFragmentTransformations.relay;

  return function flowRelayQueryPlugin(plugin) {
    var t = plugin.types;

    var activeVisitor = {
      TypeAlias: function TypeAlias(_ref, state) {
        var node = _ref.node;
        // eslint-disable-line no-shadow
        if (node.type !== "TypeAlias") {
          return;
        }

        if (node.right.type === "ObjectTypeAnnotation") {
          state.flowTypes[node.id.name] = node.right;
        }
      },
      JSXElement: function JSXElement(_ref2, state) {
        var node = _ref2.node;
        // eslint-disable-line no-shadow
        if (node.type !== "JSXElement") {
          return;
        }

        var name = node.openingElement.name.name;
        var filename = state.imports[name];
        if (filename) {
          var _visitor = {
            CallExpression: function CallExpression(p) {
              var n = p.node;

              var reactComponentName = void 0;
              var fragmentObject = void 0;

              if (state.imports[genFragFromPropsNameFor]) {
                if (n.type === "CallExpression" && n.callee.type === "Identifier" && n.callee.name === genFragFromPropsNameFor) {
                  var arg1 = n.arguments[0];
                  if (arg1.type === "Identifier") {
                    reactComponentName = arg1.name;

                    var possibleFragmentObject = p.findParent(function (_) {
                      return t.isObjectExpression(_);
                    });
                    if (possibleFragmentObject && possibleFragmentObject.node.type === "ObjectExpression") {
                      fragmentObject = possibleFragmentObject.node;
                    }
                  }
                }
              }

              if (n.type === "CallExpression" && n.arguments.length === 2) {
                var _n$arguments = _slicedToArray(n.arguments, 2),
                    _arg = _n$arguments[0],
                    arg2 = _n$arguments[1];

                if (_arg.type !== "Identifier" || arg2.type !== "ObjectExpression") {
                  return;
                }

                reactComponentName = _arg.name;
                var fragment = arg2.properties.find(function (_) {
                  return _.key.type === "Identifier" && _.key.name === "fragments";
                });
                if (fragment && fragment.value.type === "ObjectExpression") {
                  fragmentObject = fragment.value;
                }
              }

              if (reactComponentName && fragmentObject) {
                var fragmentNames = fragmentObject.properties.reduce(function (fragNames, property) {
                  if (property.key.type === "Identifier") {
                    fragNames.push(property.key.name);
                  }
                  return fragNames;
                }, []);
                state.componentContainerFragments[reactComponentName] = fragmentNames;
              }
            }
          };
          (0, _parse.parseFile)(filename, _visitor, state);
        }
      },
      ClassDeclaration: function ClassDeclaration(_ref3, state) {
        var node = _ref3.node;
        // eslint-disable-line no-shadow
        if (node.type !== "ClassDeclaration") {
          return;
        }

        var _ref4 = (0, _react.parseReactComponentClass)(node) || {},
            className = _ref4.className,
            propType = _ref4.propType;

        if (className && propType) {
          state.componentPropTypes[className] = propType;
        }
      },
      ArrowFunctionExpression: function ArrowFunctionExpression(_ref5, state) {
        var node = _ref5.node,
            parent = _ref5.parent;
        // eslint-disable-line no-shadow
        if (node.type !== "ArrowFunctionExpression") {
          return;
        }

        var functionName = parent && parent.id && parent.id.name;

        if (functionName && node.params.length === 1) {
          var typeAnnotation = node.params[0].typeAnnotation;
          typeAnnotation = typeAnnotation && typeAnnotation.typeAnnotation;

          if (typeAnnotation && typeAnnotation.type === "GenericTypeAnnotation") {
            state.componentPropTypes[functionName] = typeAnnotation.id.name;
          }
        }
      },


      // is this the fragment generate marker function
      CallExpression: function CallExpression(path, state) {
        var node = path.node,
            parent = path.parent;

        if (node.type !== "CallExpression") {
          return;
        }

        var argumentIndex = 0;
        var reactComponentNames = [];
        if (node.callee.name === genFragFromPropsName) {
          var relayCreateContainer = path.findParent(function (p) {
            return t.isCallExpression(p);
          });
          if (!relayCreateContainer || relayCreateContainer.node.type !== "CallExpression") {
            return;
          }

          var argPaths = relayCreateContainer.get("arguments");
          var arg1Path = Array.isArray(argPaths) && argPaths[0];
          if (!arg1Path) {
            throw new Error("Could not find first argument for Relay.createContainer");
          }

          if (arg1Path.node.type === "Identifier") {
            reactComponentNames.push(arg1Path.node.name);
          } else {
            arg1Path.traverse({
              Identifier: function Identifier(identifierPath) {
                if (identifierPath.node.type === "Identifier") {
                  reactComponentNames.push(identifierPath.node.name);
                }
              }
            });
          }
        } else if (node.callee.name === genFragFromPropsNameFor) {
          argumentIndex = 1;

          var componentArg = node.arguments[0];
          if (componentArg && componentArg.type === "Identifier") {
            var _reactComponentName = componentArg.name;
            reactComponentNames.push(_reactComponentName);
          }
        } else {
          return;
        }

        var typeName = reactComponentNames.reduce(function (result, reactComponentName) {
          return result || state.componentPropTypes[reactComponentName];
        }, null);
        if (!typeName) {
          var reactComponentNamesStr = reactComponentNames.join(", ");
          throw new Error("Could not find flow prop types for possible react components [" + reactComponentNamesStr + "]");
        }
        var reactComponentName = reactComponentNames[0];

        var type = state.flowTypes[typeName];
        if (!type) {
          throw new Error("There is no flow type object with name " + typeName);
        }

        var fragmentKey = parent && t.isProperty(parent) && parent.key.name;
        var typeAtKey = type.properties.find(function (_) {
          return _.key.name === fragmentKey;
        });
        if (!typeAtKey) {
          throw new Error("There is no property named '" + fragmentKey + "' in flow type " + typeName);
        }

        var generateFragmentOptions = (0, _fragmentOptions.calculateFragmentOptions)(node, argumentIndex);
        var fragmentType = generateFragmentOptions.type || uppercaseFirstChar(typeAtKey.key.name);
        var fragmentName = generateFragmentOptions.name || defaultFragmentName(reactComponentName, fragmentType);
        var fragmentDirectives = generateFragmentOptions.directives || {};

        (0, _graphql.checkPropsObjectTypeMatchesSchema)(schema, fragmentType, typeAtKey, state.flowTypes);
        var graphQlQuery = (0, _graphql.toGraphQLQueryString)(fragmentName, fragmentType, fragmentDirectives, typeAtKey, state.componentContainerFragments, childFragmentTransformations, state.flowTypes);

        var templateTag = generateFragmentOptions.templateTag || defaultTemplateTag;
        var taggedTemplateGraphQLQuery = templateTag + "`" + graphQlQuery + "`";

        // relay needs a start location on the Relay.QL template string
        var start = node.loc.start;
        path.replaceWithSourceString(taggedTemplateGraphQLQuery);
        if (path.node.type === "ArrowFunctionExpression") {
          path.node.body.loc = { start: start };
        }
      }
    };

    var importVisitor = {
      ImportDeclaration: function ImportDeclaration(path, state) {
        var node = path.node;
        if (node.type !== "ImportDeclaration") {
          return;
        }

        var _ref6 = (0, _import.parseImport)(node, state.filename) || {},
            filename = _ref6.filename,
            variables = _ref6.variables;

        if (filename) {
          if ((0, _import.isTypeImport)(node)) {
            var _visitor2 = {
              TypeAlias: function TypeAlias(_ref7) {
                var n = _ref7.node;
                // eslint-disable-line no-shadow, no-unused-vars
                if (n.type !== "TypeAlias") {
                  return;
                }

                var typeName = n.id.name;
                if (variables.indexOf(typeName) >= 0 && n.right.type === "ObjectTypeAnnotation") {
                  state.flowTypes[typeName] = n.right;
                }
              }
            };
            (0, _parse.parseFile)(filename, _visitor2, {});
          } else {
            variables.forEach(function (variable) {
              state.imports[variable] = filename;
            });
          }
        }

        // remove the marker function import
        if (node.specifiers.find(function (_) {
          return _.local.name === genFragFromPropsName || _.local.name === genFragFromPropsNameFor;
        })) {
          path.remove();
        }
      }
    };

    return {
      visitor: {
        Program: function Program(path, state) {
          var imports = {};
          var flowTypes = {};
          var filename = state.file.opts.filename;
          path.traverse(importVisitor, { imports: imports, flowTypes: flowTypes, filename: filename });

          if (imports[genFragFromPropsName] || imports[genFragFromPropsNameFor]) {
            path.traverse(activeVisitor, {
              imports: imports,
              flowTypes: flowTypes,
              componentPropTypes: {},
              componentContainerFragments: {}
            });
          }
        }
      }
    };
  };
};

var _ChildFragmentTransformations = require("./ChildFragmentTransformations");

var _import = require("./utils/import");

var _react = require("./utils/react");

var _parse = require("./utils/parse");

var _fragmentOptions = require("./utils/fragmentOptions");

var _graphql = require("./utils/graphql");

var uppercaseFirstChar = function uppercaseFirstChar(str) {
  return str.charAt(0).toUpperCase() + str.slice(1);
};