"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _babelRelayPlugin = require("babel-relay-plugin");

var _babelRelayPlugin2 = _interopRequireDefault(_babelRelayPlugin);

var _flowRelayQueryPlugin = require("./flowRelayQueryPlugin");

var _flowRelayQueryPlugin2 = _interopRequireDefault(_flowRelayQueryPlugin);

var _createSchema = require("./createSchema");

var _createSchema2 = _interopRequireDefault(_createSchema);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createPlugin(schemaProvider) {
  var babelpluginOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var pluginOptions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  var babelRelayPlugin = (0, _babelRelayPlugin2.default)(schemaProvider, babelpluginOptions);

  var schema = (0, _createSchema2.default)(schemaProvider);
  var flowRelayQueryPlugin = (0, _flowRelayQueryPlugin2.default)(schema, pluginOptions);

  return function plugin(babel) {
    return _extends({
      inherits: babelRelayPlugin(babel)
    }, flowRelayQueryPlugin(babel));
  };
}

// module.exports because this file will be included using require()
module.exports = createPlugin;